class: Workflow
cwlVersion: cwl:draft-3
hints:
- class: DockerRequirement
  dockerImageId: bcbio/bcbio
  dockerPull: bcbio/bcbio
inputs:
- id: '#config__algorithm__align_split_size'
  type:
    items: long
    type: array
- id: '#config__algorithm__validate'
  type:
    items: File
    type: array
- id: '#reference__fasta__base'
  type:
    items: File
    type: array
- id: '#genome_resources__variation__lcr'
  type:
    items: File
    type: array
- id: '#reference__snpeff'
  type:
    items: File
    type: array
- id: '#config__algorithm__variantcaller'
  type:
    items:
      items: string
      type: array
    type: array
- id: '#genome_resources__coverage__coverage_problem_dir'
  type:
    items: string
    type: array
- id: '#genome_resources__rnaseq__transcripts_mask'
  type:
    items: File
    type: array
- id: '#genome_resources__variation__train_1000g'
  type:
    items: File
    type: array
- id: '#reference__rtg'
  type:
    items: File
    type: array
- id: '#genome_resources__variation__qsignature'
  type:
    items: File
    type: array
- id: '#genome_resources__variation__train_hapmap'
  type:
    items: File
    type: array
- id: '#rgnames__lb'
  type:
    items: 'null'
    type: array
- id: '#rgnames__rg'
  type:
    items: string
    type: array
- id: '#config__algorithm__realign'
  type:
    items: string
    type: array
- id: '#metadata__batch'
  type:
    items: 'null'
    type: array
- id: '#rgnames__lane'
  type:
    items: string
    type: array
- id: '#reference__snap__indexes'
  type:
    items: File
    type: array
- id: '#config__algorithm__nomap_split_targets'
  type:
    items: long
    type: array
- id: '#genome_resources__variation__sv_repeat'
  type:
    items: File
    type: array
- id: '#genome_resources__coverage__MIG'
  type:
    items: File
    type: array
- id: '#config__algorithm__nomap_split_size'
  type:
    items: long
    type: array
- id: '#files'
  type:
    items:
      items: File
      type: array
    type: array
- id: '#genome_resources__rnaseq__dexseq'
  type:
    items: File
    type: array
- id: '#description'
  type:
    items: string
    type: array
- id: '#config__algorithm__validate_regions'
  type:
    items: File
    type: array
- id: '#genome_resources__rnaseq__transcriptome_index__tophat'
  type:
    items: string
    type: array
- id: '#config__algorithm__aligner'
  type:
    items: string
    type: array
- id: '#genome_resources__variation__train_omni'
  type:
    items: File
    type: array
- id: '#rgnames__pl'
  type:
    items: string
    type: array
- id: '#genome_build'
  type:
    items: string
    type: array
- id: '#rgnames__pu'
  type:
    items: string
    type: array
- id: '#config__algorithm__recalibrate'
  type:
    items: string
    type: array
- id: '#metadata__phenotype'
  type:
    items: string
    type: array
- id: '#genome_resources__rnaseq__transcripts'
  type:
    items: File
    type: array
- id: '#genome_resources__aliases__human'
  type:
    items: string
    type: array
- id: '#genome_resources__variation__encode_blacklist'
  type:
    items: File
    type: array
- id: '#config__algorithm__tools_off'
  type:
    items:
      items: string
      type: array
    type: array
- id: '#genome_resources__variation__dbsnp'
  type:
    items: File
    type: array
- id: '#config__algorithm__mark_duplicates'
  type:
    items: string
    type: array
- id: '#genome_resources__variation__ancestral'
  type:
    items: File
    type: array
- id: '#vrn_file'
  type:
    items: 'null'
    type: array
- id: '#genome_resources__version'
  type:
    items: long
    type: array
- id: '#genome_resources__variation__cosmic'
  type:
    items: File
    type: array
- id: '#genome_resources__rnaseq__refflat'
  type:
    items: File
    type: array
- id: '#config__algorithm__qc'
  type:
    items:
      items: string
      type: array
    type: array
- id: '#analysis'
  type:
    items: string
    type: array
- id: '#rgnames__sample'
  type:
    items: string
    type: array
- id: '#config__algorithm__tools_on'
  type:
    items:
      items: string
      type: array
    type: array
- id: '#config__algorithm__effects'
  type:
    items: string
    type: array
- id: '#config__algorithm__variant_regions'
  type:
    items: File
    type: array
- id: '#genome_resources__aliases__ensembl'
  type:
    items: string
    type: array
- id: '#metadata__sex'
  type:
    items: string
    type: array
- id: '#genome_resources__variation__train_indels'
  type:
    items: File
    type: array
- id: '#genome_resources__aliases__snpeff'
  type:
    items: string
    type: array
- id: '#config__algorithm__archive'
  type:
    items:
      items: 'null'
      type: array
    type: array
outputs:
- id: '#align_bam'
  linkMerge: merge_flattened
  source: '#alignment.align_bam'
  type:
    items: File
    secondaryFiles:
    - .bai
    type: array
- id: '#vrn_file'
  linkMerge: merge_flattened
  source: '#variantcall.vrn_file'
  type:
    items: File
    secondaryFiles:
    - .tbi
    type: array
- id: '#validate__summary'
  linkMerge: merge_flattened
  source: '#variantcall.validate__summary'
  type:
    items:
    - File
    - 'null'
    type: array
- id: '#summary__multiqc'
  linkMerge: merge_flattened
  source: '#multiqc_summary.summary__multiqc'
  type:
    items:
    - File
    - 'null'
    type: array
requirements:
- class: EnvVarRequirement
  envDef:
  - envName: MPLCONFIGDIR
    envValue: .
- class: ScatterFeatureRequirement
- class: StepInputExpressionRequirement
- class: SubworkflowFeatureRequirement
- class: InlineJavascriptRequirement
steps:
- id: '#alignment'
  inputs:
  - id: '#alignment.files'
    source: '#files'
  - id: '#alignment.config__algorithm__align_split_size'
    source: '#config__algorithm__align_split_size'
  - id: '#alignment.config__algorithm__aligner'
    source: '#config__algorithm__aligner'
  - id: '#alignment.description'
    source: '#description'
  - id: '#alignment.reference__fasta__base'
    source: '#reference__fasta__base'
  - id: '#alignment.rgnames__pl'
    source: '#rgnames__pl'
  - id: '#alignment.rgnames__sample'
    source: '#rgnames__sample'
  - id: '#alignment.rgnames__pu'
    source: '#rgnames__pu'
  - id: '#alignment.rgnames__lane'
    source: '#rgnames__lane'
  - id: '#alignment.rgnames__rg'
    source: '#rgnames__rg'
  - id: '#alignment.rgnames__lb'
    source: '#rgnames__lb'
  - id: '#alignment.reference__snap__indexes'
    source: '#reference__snap__indexes'
  - id: '#alignment.config__algorithm__mark_duplicates'
    source: '#config__algorithm__mark_duplicates'
  outputs:
  - id: '#alignment.align_bam'
  - id: '#alignment.work_bam-plus__disc'
  - id: '#alignment.work_bam-plus__sr'
  - id: '#alignment.hla__fastq'
  run: wf-alignment.cwl
  scatter:
  - '#alignment.files'
  - '#alignment.config__algorithm__align_split_size'
  - '#alignment.config__algorithm__aligner'
  - '#alignment.description'
  - '#alignment.reference__fasta__base'
  - '#alignment.rgnames__pl'
  - '#alignment.rgnames__sample'
  - '#alignment.rgnames__pu'
  - '#alignment.rgnames__lane'
  - '#alignment.rgnames__rg'
  - '#alignment.rgnames__lb'
  - '#alignment.reference__snap__indexes'
  - '#alignment.config__algorithm__mark_duplicates'
  scatterMethod: dotproduct
- id: '#prep_samples'
  inputs:
  - id: '#prep_samples.config__algorithm__variant_regions'
    source: '#config__algorithm__variant_regions'
  - id: '#prep_samples.reference__fasta__base'
    source: '#reference__fasta__base'
  - id: '#prep_samples.description'
    source: '#description'
  outputs:
  - id: '#prep_samples.config__algorithm__variant_regions'
  - id: '#prep_samples.config__algorithm__variant_regions_merged'
  run: steps/prep_samples.cwl
  scatter:
  - '#prep_samples.config__algorithm__variant_regions'
  - '#prep_samples.reference__fasta__base'
  - '#prep_samples.description'
  scatterMethod: dotproduct
- id: '#postprocess_alignment'
  inputs:
  - id: '#postprocess_alignment.align_bam'
    source: '#alignment.align_bam'
  - id: '#postprocess_alignment.config__algorithm__variant_regions'
    source: '#prep_samples.config__algorithm__variant_regions'
  - id: '#postprocess_alignment.config__algorithm__variant_regions_merged'
    source: '#prep_samples.config__algorithm__variant_regions_merged'
  - id: '#postprocess_alignment.config__algorithm__recalibrate'
    source: '#config__algorithm__recalibrate'
  - id: '#postprocess_alignment.reference__fasta__base'
    source: '#reference__fasta__base'
  - id: '#postprocess_alignment.description'
    source: '#description'
  outputs:
  - id: '#postprocess_alignment.config__algorithm__coverage_interval'
  - id: '#postprocess_alignment.config__algorithm__variant_regions'
  - id: '#postprocess_alignment.config__algorithm__variant_regions_merged'
  - id: '#postprocess_alignment.regions__callable'
  - id: '#postprocess_alignment.regions__sample_callable'
  - id: '#postprocess_alignment.regions__nblock'
  - id: '#postprocess_alignment.regions__highdepth'
  - id: '#postprocess_alignment.regions__offtarget_stats'
  run: steps/postprocess_alignment.cwl
  scatter:
  - '#postprocess_alignment.align_bam'
  - '#postprocess_alignment.config__algorithm__variant_regions'
  - '#postprocess_alignment.config__algorithm__variant_regions_merged'
  - '#postprocess_alignment.config__algorithm__recalibrate'
  - '#postprocess_alignment.reference__fasta__base'
  - '#postprocess_alignment.description'
  scatterMethod: dotproduct
- id: '#combine_sample_regions'
  inputs:
  - id: '#combine_sample_regions.regions__callable'
    source: '#postprocess_alignment.regions__callable'
  - id: '#combine_sample_regions.regions__nblock'
    source: '#postprocess_alignment.regions__nblock'
  - id: '#combine_sample_regions.config__algorithm__nomap_split_size'
    source: '#config__algorithm__nomap_split_size'
  - id: '#combine_sample_regions.config__algorithm__nomap_split_targets'
    source: '#config__algorithm__nomap_split_targets'
  - id: '#combine_sample_regions.reference__fasta__base'
    source: '#reference__fasta__base'
  - id: '#combine_sample_regions.description'
    source: '#description'
  outputs:
  - id: '#combine_sample_regions.config__algorithm__callable_regions'
  - id: '#combine_sample_regions.config__algorithm__non_callable_regions'
  - id: '#combine_sample_regions.config__algorithm__callable_count'
  run: steps/combine_sample_regions.cwl
- id: '#batch_for_variantcall'
  inputs:
  - id: '#batch_for_variantcall.analysis'
    source: '#analysis'
  - id: '#batch_for_variantcall.genome_build'
    source: '#genome_build'
  - id: '#batch_for_variantcall.align_bam'
    source: '#alignment.align_bam'
  - id: '#batch_for_variantcall.config__algorithm__callable_regions'
    source: '#combine_sample_regions.config__algorithm__callable_regions'
  - id: '#batch_for_variantcall.metadata__batch'
    source: '#metadata__batch'
  - id: '#batch_for_variantcall.metadata__phenotype'
    source: '#metadata__phenotype'
  - id: '#batch_for_variantcall.regions__callable'
    source: '#postprocess_alignment.regions__callable'
  - id: '#batch_for_variantcall.config__algorithm__variantcaller'
    source: '#config__algorithm__variantcaller'
  - id: '#batch_for_variantcall.config__algorithm__variant_regions'
    source: '#postprocess_alignment.config__algorithm__variant_regions'
  - id: '#batch_for_variantcall.config__algorithm__validate'
    source: '#config__algorithm__validate'
  - id: '#batch_for_variantcall.config__algorithm__validate_regions'
    source: '#config__algorithm__validate_regions'
  - id: '#batch_for_variantcall.config__algorithm__tools_on'
    source: '#config__algorithm__tools_on'
  - id: '#batch_for_variantcall.reference__fasta__base'
    source: '#reference__fasta__base'
  - id: '#batch_for_variantcall.reference__rtg'
    source: '#reference__rtg'
  - id: '#batch_for_variantcall.genome_resources__variation__cosmic'
    source: '#genome_resources__variation__cosmic'
  - id: '#batch_for_variantcall.genome_resources__variation__dbsnp'
    source: '#genome_resources__variation__dbsnp'
  - id: '#batch_for_variantcall.description'
    source: '#description'
  outputs:
  - id: '#batch_rec'
  run: steps/batch_for_variantcall.cwl
- id: '#variantcall'
  inputs:
  - id: '#variantcall.description'
    source: '#batch_rec'
    valueFrom: $(self.description)
  - id: '#variantcall.config__algorithm__validate'
    source: '#batch_rec'
    valueFrom: $(self.config__algorithm__validate)
  - id: '#variantcall.reference__fasta__base'
    source: '#batch_rec'
    valueFrom: $(self.reference__fasta__base)
  - id: '#variantcall.config__algorithm__variantcaller'
    source: '#batch_rec'
    valueFrom: $(self.config__algorithm__variantcaller)
  - id: '#variantcall.reference__rtg'
    source: '#batch_rec'
    valueFrom: $(self.reference__rtg)
  - id: '#variantcall.metadata__batch'
    source: '#batch_rec'
    valueFrom: $(self.metadata__batch)
  - id: '#variantcall.config__algorithm__validate_regions'
    source: '#batch_rec'
    valueFrom: $(self.config__algorithm__validate_regions)
  - id: '#variantcall.genome_build'
    source: '#batch_rec'
    valueFrom: $(self.genome_build)
  - id: '#variantcall.metadata__phenotype'
    source: '#batch_rec'
    valueFrom: $(self.metadata__phenotype)
  - id: '#variantcall.genome_resources__variation__dbsnp'
    source: '#batch_rec'
    valueFrom: $(self.genome_resources__variation__dbsnp)
  - id: '#variantcall.genome_resources__variation__cosmic'
    source: '#batch_rec'
    valueFrom: $(self.genome_resources__variation__cosmic)
  - id: '#variantcall.analysis'
    source: '#batch_rec'
    valueFrom: $(self.analysis)
  - id: '#variantcall.config__algorithm__tools_on'
    source: '#batch_rec'
    valueFrom: $(self.config__algorithm__tools_on)
  - id: '#variantcall.config__algorithm__variant_regions'
    source: '#batch_rec'
    valueFrom: $(self.config__algorithm__variant_regions)
  - id: '#variantcall.align_bam'
    source: '#batch_rec'
    valueFrom: $(self.align_bam)
  - id: '#variantcall.regions__callable'
    source: '#batch_rec'
    valueFrom: $(self.regions__callable)
  - id: '#variantcall.config__algorithm__callable_regions'
    source: '#batch_rec'
    valueFrom: $(self.config__algorithm__callable_regions)
  outputs:
  - id: '#variantcall.validate__summary'
  - id: '#variantcall.validate__tp'
  - id: '#variantcall.validate__fp'
  - id: '#variantcall.validate__fn'
  - id: '#variantcall.vrn_file'
  run: wf-variantcall.cwl
  scatter:
  - '#variantcall.description'
  - '#variantcall.config__algorithm__validate'
  - '#variantcall.reference__fasta__base'
  - '#variantcall.config__algorithm__variantcaller'
  - '#variantcall.reference__rtg'
  - '#variantcall.metadata__batch'
  - '#variantcall.config__algorithm__validate_regions'
  - '#variantcall.genome_build'
  - '#variantcall.metadata__phenotype'
  - '#variantcall.genome_resources__variation__dbsnp'
  - '#variantcall.genome_resources__variation__cosmic'
  - '#variantcall.analysis'
  - '#variantcall.config__algorithm__tools_on'
  - '#variantcall.config__algorithm__variant_regions'
  - '#variantcall.align_bam'
  - '#variantcall.regions__callable'
  - '#variantcall.config__algorithm__callable_regions'
  scatterMethod: dotproduct
- id: '#pipeline_summary'
  inputs:
  - id: '#pipeline_summary.align_bam'
    source: '#alignment.align_bam'
  - id: '#pipeline_summary.analysis'
    source: '#analysis'
  - id: '#pipeline_summary.reference__fasta__base'
    source: '#reference__fasta__base'
  - id: '#pipeline_summary.config__algorithm__qc'
    source: '#config__algorithm__qc'
  - id: '#pipeline_summary.config__algorithm__variant_regions'
    source: '#postprocess_alignment.config__algorithm__variant_regions'
  - id: '#pipeline_summary.regions__offtarget_stats'
    source: '#postprocess_alignment.regions__offtarget_stats'
  - id: '#pipeline_summary.description'
    source: '#description'
  outputs:
  - id: '#pipeline_summary.summary__qc__samtools'
  - id: '#pipeline_summary.summary__qc__fastqc'
  - id: '#pipeline_summary.coverage__all'
  - id: '#pipeline_summary.coverage__problems'
  run: steps/pipeline_summary.cwl
  scatter:
  - '#pipeline_summary.align_bam'
  - '#pipeline_summary.analysis'
  - '#pipeline_summary.reference__fasta__base'
  - '#pipeline_summary.config__algorithm__qc'
  - '#pipeline_summary.config__algorithm__variant_regions'
  - '#pipeline_summary.regions__offtarget_stats'
  - '#pipeline_summary.description'
  scatterMethod: dotproduct
- id: '#multiqc_summary'
  inputs:
  - id: '#multiqc_summary.summary__qc__samtools'
    source: '#pipeline_summary.summary__qc__samtools'
  - id: '#multiqc_summary.summary__qc__fastqc'
    source: '#pipeline_summary.summary__qc__fastqc'
  - id: '#multiqc_summary.description'
    source: '#description'
  outputs:
  - id: '#multiqc_summary.summary__multiqc'
  run: steps/multiqc_summary.cwl
