arguments:
- position: 0
  valueFrom: sentinel-runtime=$(runtime)
baseCommand:
- bcbio_nextgen.py
- runfn
- process_alignment
- cwl
class: CommandLineTool
cwlVersion: cwl:draft-3
hints:
- class: ResourceRequirement
  coresMin: 16
  ramMin: 65536
  tmpdirMin: 4868
inputs:
- default: single-parallel
  id: '#sentinel-parallel'
  inputBinding:
    itemSeparator: ;;
    position: 0
    prefix: sentinel-parallel=
    separate: false
  type: string
- default: '["work_bam","align_bam","hla__fastq","work_bam-plus__disc","work_bam-plus__sr"]'
  id: '#sentinel-outputs'
  inputBinding:
    itemSeparator: ;;
    position: 1
    prefix: sentinel-outputs=
    separate: false
  type: string
- id: '#files'
  inputBinding:
    itemSeparator: ;;
    position: 2
    prefix: files=
    separate: false
  type:
    items: File
    secondaryFiles:
    - .gbi
    type: array
- id: '#reference__fasta__base'
  inputBinding:
    itemSeparator: ;;
    position: 3
    prefix: reference__fasta__base=
    separate: false
  type: File
- id: '#rgnames__pl'
  inputBinding:
    itemSeparator: ;;
    position: 4
    prefix: rgnames__pl=
    separate: false
  type: string
- id: '#rgnames__sample'
  inputBinding:
    itemSeparator: ;;
    position: 5
    prefix: rgnames__sample=
    separate: false
  type: string
- id: '#rgnames__pu'
  inputBinding:
    itemSeparator: ;;
    position: 6
    prefix: rgnames__pu=
    separate: false
  type: string
- id: '#rgnames__lane'
  inputBinding:
    itemSeparator: ;;
    position: 7
    prefix: rgnames__lane=
    separate: false
  type: string
- id: '#rgnames__rg'
  inputBinding:
    itemSeparator: ;;
    position: 8
    prefix: rgnames__rg=
    separate: false
  type: string
- id: '#rgnames__lb'
  inputBinding:
    itemSeparator: ;;
    position: 9
    prefix: rgnames__lb=
    separate: false
  type: 'null'
- id: '#reference__snap__indexes'
  inputBinding:
    itemSeparator: ;;
    position: 10
    prefix: reference__snap__indexes=
    separate: false
  type: File
- id: '#config__algorithm__aligner'
  inputBinding:
    itemSeparator: ;;
    position: 11
    prefix: config__algorithm__aligner=
    separate: false
  type: string
- id: '#config__algorithm__mark_duplicates'
  inputBinding:
    itemSeparator: ;;
    position: 12
    prefix: config__algorithm__mark_duplicates=
    separate: false
  type: string
- id: '#description'
  inputBinding:
    itemSeparator: ;;
    position: 13
    prefix: description=
    separate: false
  type: string
outputs:
- id: '#work_bam'
  type: File
- id: '#align_bam'
  type: File
- id: '#hla__fastq'
  type:
  - File
  - 'null'
- id: '#work_bam-plus__disc'
  secondaryFiles:
  - .bai
  type: File
- id: '#work_bam-plus__sr'
  secondaryFiles:
  - .bai
  type: File
